<script setup lang="ts" generic="Thing extends any, THeader extends Record<string, string>, TRow extends Record<keyof THeader, Thing>">
const props = defineProps<{
  headers: THeader;
  rows: TRow[];
}>();

defineSlots<{
  default?: (props: { row: number; col: string; value: Thing }) => any;
}>();

function assertHeaders(headers: THeader) {
  if (props.rows.length === 0) return;
  const headerKeys = Object.keys(headers);
  const rowKeys = Object.keys(props.rows[0]);
  if (headerKeys.length !== rowKeys.length) {
    throw new Error(
      `The number of headers (${headerKeys.length}) does not match the number of row keys (${rowKeys.length})`
    );
  }
  const missingHeaders = rowKeys.filter((key) => !headerKeys.includes(key));
  if (missingHeaders.length > 0) {
    throw new Error(
      `The following row keys are missing from the headers: ${missingHeaders.join(
        ', '
      )}`
    );
  }
}

assertHeaders(props.headers);
</script>

<template>
  <div class="ecl-table-responsive">
    <table class="ecl-table">
      <thead class="ecl-table__head">
        <tr class="ecl-table__row">
          <th
            v-for="(header, index) in headers"
            :key="index"
            class="ecl-table__header"
          >
            {{ header }}
          </th>
        </tr>
      </thead>
      <tbody class="ecl-table__body">
        <tr
          v-for="(row, rowIndex) in rows"
          :key="rowIndex"
          class="ecl-table__row"
        >
          <td
            v-for="(header, headerIndex) in headers"
            :key="headerIndex"
            :data-ecl-table-header="header"
            class="ecl-table__cell"
          >
            <slot
              :row="rowIndex"
              :col="(headerIndex as string)"
              :value="(row[headerIndex as keyof TRow])"
            >
              {{ row[headerIndex as keyof TRow] }}
            </slot>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>


<style scoped>

</style>